/*
 * Astri_Monitor.h
 *
 *  Created on: Jul 3, 2021
 *      Author: astrisw
 */

#ifndef INCLUDE_ASTRI_MONITOR_H_
#define INCLUDE_ASTRI_MONITOR_H_

#include <Base_Monitor.h>
#include <chrono>
#include <unordered_map>

namespace inaf::oasbo::PacketMonitors {
class AstriPacketMonitor: public BasePacketMonitor {

protected:
	std::chrono::duration<double, std::milli> timeElps;
	std::chrono::steady_clock::time_point startTime;
	std::unordered_map<std::string, size_t> lastSSCMap;
	std::unordered_map<std::string, size_t> lostsMap;
	std::chrono::steady_clock::time_point last10sTime;
	double bytesLast10s;
	size_t packsLast10s;

	void monitPacketLost(PacketLib::BasePacket &pack);

	static std::string tot_packets_key;
	static std::string tot_MB_key;
	static std::string tot_lost_key;
	static std::string byte_rate_key;
	static std::string packet_rate_key;


public:
	AstriPacketMonitor();
	void monit(PacketLib::BasePacket &pack);
	void reset();
	void printStats();
};
}
#endif /* INCLUDE_ASTRI_MONITOR_H_ */
